VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Public TV As TrueVision8
Public Scene As Scene8
Public Land As Landscape8
Public Inp As InputEngine8
Public Scr As Screen8
Public TexFactory As New TextureFactory8
Public PosX As Single, PosY As Single, PosZ As Single, Ang As Single, AngY As Single, MX As Long, MY As Long
Public Camera As New Camera8
Public Mesh As New Mesh8
Dim GCamera(0 To 1) As CameraGravity
Public Effects As New GraphicEffect8
Dim blnKoniec As Boolean
Dim blnRender As Boolean
Dim b1 As Integer
Dim b2 As Integer

Private Sub Form_Load()
   Set TV = New TrueVision8
   Set Scene = New Scene8
   Set Land = New Landscape8
   Set Scr = New Screen8
   Set Mesh = Scene.CreateMeshBuilder
   'wyczamy konsol
   TV.Console = False
   'ustawiamy tytu okna
   TV.SetWindowTitle "Aplikacja 3D"
   'wywietlenie okienka, w ktrym mona wybra mi.in. rozdzielczo
   'jeli klikniemy na Cancel, to program zakacza si
   If TV.ShowDriverDialog = False Then End
   'inicjalizacia i tworzenie obiektw
   TV.Initialize
   Set Inp = New InputEngine8
   TV.SetSearchDirectory App.Path & "\pliki"
   TexFactory.LoadTexture "powierzchnia.jpg", "Powierzchnia"
   TexFactory.LoadTexture "szczeg.jpg", "Szczegoly"
   TexFactory.LoadTexture "niebo1.jpg", "Niebo1"
   TexFactory.LoadTexture "niebo2.jpg", "Niebo2"
   TexFactory.LoadTexture "niebo3.jpg", "Niebo3"
   TexFactory.LoadTexture "niebo4.jpg", "Niebo4"
   TexFactory.LoadTexture "niebo5.jpg", "Niebo5"
   TexFactory.LoadTexture "dolne.jpg", "Dolne"
   'wyczyszczenie ekranu
   TV.Clear
   TV.RenderToScreen
   Scene.EnableMipMapping True
   Land.GenerateHugeTerrain "wysokosc.jpg", TV_PRECISION_HIGH, 1, 1, 0, 0, True 'tu m.in wielko planszy
   'wczytanie tekstury powierzchni
   Land.SetTexture GetTex("Powierzchnia")
   Land.SetTextureScale 1, 1 'skala tekstury
   Land.SetDetailTexture GetTex("Szczegoly")
   Land.SetDetailTextureScale 5, 5
   Scene.SetSkyTexture GetTex("Niebo1"), GetTex("Niebo2"), GetTex("Niebo3"), GetTex("Niebo4"), GetTex("Dolne"), GetTex("Niebo5"), 1500
   Land.Optimize
   Mesh.AddWall GetTex("Dolne"), 100, 100, 200, 200, 100, 0, 1, 1
   Mesh.AddFloor GetTex("Dolne"), 0, 0, 200, 200, 50, 1, 1
   'ustawienie kamery
   GCamera(0).X = 0
   GCamera(0).z = 0
   AngY = -1.57 ' kt patrzenia (gra/d)
   'wczamy wywietlanie iloci klatek na sekund
   TV.DisplayFPS = True
   'rozjanianie widoku przez 2 sekundy
   Effects.FadeIn 2000
   'tutaj jest ptla wywietlajca obraz
   Do
      ChangePos
      TV.Clear
      Scene.RenderSky
      Land.Render False, False
      Scene.RenderAllMeshes
      TV.RenderToScreen
      If Inp.IsKeyPressed(TV_KEY_ESCAPE) = True Then 'jak wcinite Esc, to koniec
         Scene.SetRenderMode TV_SOLID
         blnKoniec = True
         Effects.FadeOut 2500
      End If
   Loop Until Effects.FadeFinished = True And blnKoniec = True
   Set TV = Nothing
   End
End Sub

Public Sub ChangePos()
   GCamera(1) = GCamera(0)
   'reakcja na klawisze: strzaki z shiftem i bez
   GCamera(1) = GCamera(0)
    If Inp.IsKeyPressed(TV_KEY_UP) = True And (Inp.IsKeyPressed(TV_KEY_LEFTSHIFT) Or Inp.IsKeyPressed(TV_KEY_RIGHTSHIFT)) Then
      GCamera(1).X = GCamera(0).X + Cos(GCamera(0).Ang) * TV.TimeElapsed * 0.3
      GCamera(1).z = GCamera(0).z + Sin(GCamera(0).Ang) * TV.TimeElapsed * 0.3
   End If
   If Inp.IsKeyPressed(TV_KEY_UP) = True And (Inp.IsKeyPressed(TV_KEY_LEFTSHIFT) Or Inp.IsKeyPressed(TV_KEY_RIGHTSHIFT)) = False Then
      GCamera(1).X = GCamera(0).X + Cos(GCamera(0).Ang) * TV.TimeElapsed * 0.1
      GCamera(1).z = GCamera(0).z + Sin(GCamera(0).Ang) * TV.TimeElapsed * 0.1
   End If
   If Inp.IsKeyPressed(TV_KEY_DOWN) = True And (Inp.IsKeyPressed(TV_KEY_LEFTSHIFT) Or Inp.IsKeyPressed(TV_KEY_RIGHTSHIFT)) Then
      GCamera(1).X = GCamera(0).X - Cos(GCamera(0).Ang) * TV.TimeElapsed * 0.21
      GCamera(1).z = GCamera(0).z - Sin(GCamera(0).Ang) * TV.TimeElapsed * 0.21
   End If
   If Inp.IsKeyPressed(TV_KEY_DOWN) = True And (Inp.IsKeyPressed(TV_KEY_LEFTSHIFT) Or Inp.IsKeyPressed(TV_KEY_RIGHTSHIFT)) = False Then
      GCamera(1).X = GCamera(0).X - Cos(GCamera(0).Ang) * TV.TimeElapsed * 0.07
      GCamera(1).z = GCamera(0).z - Sin(GCamera(0).Ang) * TV.TimeElapsed * 0.07
   End If
   If Inp.IsKeyPressed(TV_KEY_LEFT) = True Then
      GCamera(1).Ang = GCamera(0).Ang + TV.TimeElapsed * 0.005
   End If
   If Inp.IsKeyPressed(TV_KEY_RIGHT) = True Then
      GCamera(1).Ang = GCamera(0).Ang - TV.TimeElapsed * 0.005
   End If
   'jeli nacinity zostanie klawisz S, tworzony jest zrzut do pliku
   If Inp.IsKeyPressed(TV_KEY_S) = True Then
       TV.ScreenShot "c:\Screenshot.bmp"
   End If
   'klawiszmi 1,2,3 mona wybiera sposb wywietlania
   If Inp.IsKeyPressed(TV_KEY_1) Then Scene.SetRenderMode TV_SOLID 'zwyky - tekstury wypwniaj wntrza trjktw
   If Inp.IsKeyPressed(TV_KEY_2) Then Scene.SetRenderMode TV_LINE 'wida tylko krawdzie trjktw
   If Inp.IsKeyPressed(TV_KEY_3) Then Scene.SetRenderMode TV_POINT 'tylko wierzchoki trjktw
   'sprawdzenie stanu myszy i odpowiednie ustawienie kamery
   'Shift przyspiesza
   Inp.GetMouseState MX, MY, b1, b2
   If b1 <> 0 Then
      If (Inp.IsKeyPressed(TV_KEY_LEFTSHIFT) Or Inp.IsKeyPressed(TV_KEY_RIGHTSHIFT)) Then
         GCamera(1).X = GCamera(0).X + Cos(GCamera(0).Ang) * TV.TimeElapsed * 0.3
         GCamera(1).z = GCamera(0).z + Sin(GCamera(0).Ang) * TV.TimeElapsed * 0.3
      Else
         GCamera(1).X = GCamera(0).X + Cos(GCamera(0).Ang) * TV.TimeElapsed * 0.1
         GCamera(1).z = GCamera(0).z + Sin(GCamera(0).Ang) * TV.TimeElapsed * 0.1
      End If
   End If
   If b2 <> 0 Then
      If (Inp.IsKeyPressed(TV_KEY_LEFTSHIFT) Or Inp.IsKeyPressed(TV_KEY_RIGHTSHIFT)) Then
         GCamera(1).X = GCamera(0).X - Cos(GCamera(0).Ang) * TV.TimeElapsed * 0.21
         GCamera(1).z = GCamera(0).z - Sin(GCamera(0).Ang) * TV.TimeElapsed * 0.21
      Else
         GCamera(1).X = GCamera(0).X - Cos(GCamera(0).Ang) * TV.TimeElapsed * 0.07
         GCamera(1).z = GCamera(0).z - Sin(GCamera(0).Ang) * TV.TimeElapsed * 0.07
      End If
   End If
   AngY = AngY - (MY / 100)
   If AngY > ((22 / 7) * 0.1) Then
      AngY = ((22 / 7) * 0.1)
   End If
   If AngY < -((22 / 7) * 0.8) Then
      AngY = -((22 / 7) * 0.8)
   End If
   GCamera(1).Ang = GCamera(1).Ang - (MX / 100)
   GCamera(1).y = Land.GetHeight(GCamera(1).X, GCamera(1).z) + 20 'wysoko kamery=wysoko "gruntu" + 20
   GCamera(0) = GCamera(1)
   'po sprawdzeniu stanu klawiatury i myszy i wykonaniu oblicze nastpuje ustawienie kamery, wyjcie z procedury i powrt do ptli
   Scene.SetCamera GCamera(0).X, GCamera(0).y, GCamera(0).z, GCamera(0).X + Cos(GCamera(0).Ang), GCamera(0).y + Cos(AngY), GCamera(0).z + Sin(GCamera(0).Ang)
End Sub

